fun main() {
    // A = 0   X = 0   Win: X0 - C2, Z2 - B1, Y1 - A0
    // B = 1   Y = 1   Win: (r+2) % 3) == c; Lose: ((r+1) % 3) == c
    // C = 2   Z = 2   Points = (r + 1) + ((3-c) - (r+1) % 3) * 3
    fun part1(input: List<String>): Int {
        return input.sumOf {
            val c = it[0] - 'A'
            val r = it[2] - 'X'
            (r + 1) + ((r - c + 4) % 3) * 3
        }
    }

    fun part2(input: List<String>): Int {
        return input.sumOf {
            val c = it[0] - 'A'
            val l = it[2] - 'X'
            val r = (l - c * 2 + 8) % 3
            (r + 1) + ((r - c + 4) % 3) * 3
        }
    }

    // test if implementation meets criteria from the description, like:
    val testInput = readInput("aoc2022/Day02_test")
    check(part1(testInput) == 15)
    check(part2(testInput) == 12)

    val input = readInput("aoc2022/Day02")
    part1(input).println()
    part2(input).println()
}
